// testapp.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#import <msxml3.dll> named_guids
using namespace MSXML2;


int main(int argc, char* argv[])
{

	CoInitialize(NULL);	

	variant_t vResult;
	void *output  = NULL;	
    MSXML2::IXMLDOMDocumentPtr pXml(MSXML2::CLSID_DOMDocument);
    MSXML2::IXMLDOMDocumentPtr pXslt(CLSID_FreeThreadedDOMDocument);
	IXSLTemplatePtr pTemplate(CLSID_XSLTemplate);
	IXSLProcessorPtr pProcessor;
	IStream *pOutStream;

	try{
	// load xml file with data and xsl file to transform xml -> html
	vResult = pXml->load(_bstr_t("books.xml"));
	vResult = pXslt->load(_bstr_t("trans.xsl"));	
	} catch(_com_error &e) {		
		printf("Error loading XML files : %s\n",(const char*)_bstr_t(e.Description()));	
		exit(-1);
	}
		
	// initialize xsl template with just loaded xsl file and
	// create xsl processor that will do the actual transformation,
	// the same processor can be used to transforma several
	// different xml files	
	try{
	vResult = pTemplate->putref_stylesheet(pXslt);
	pProcessor = pTemplate->createProcessor();
	} catch(_com_error &e) {		
		printf("Error setting XSL style sheet : %s\n",(const char*)_bstr_t(e.Description()));	
		exit(-1);
	}

	// prepare Stream object to store results of transformation,
	// and set processor output to it
	CreateStreamOnHGlobal(NULL,TRUE,&pOutStream);		
	pProcessor->put_output(_variant_t(pOutStream));

	// attach to processor xml file we want to transform,
	// add one parameter maxprice with value 35 and
	// do the transoformation	
	vResult = pProcessor->put_input(_variant_t((IUnknown*)pXml));		
	pProcessor->addParameter(_bstr_t("maxprice"),_variant_t("35"),_bstr_t(""));		
	pProcessor->transform();
				
	//get results of transformation and print it to stdout
	HGLOBAL hg = NULL;
    pOutStream->Write((void const*)"\0",1,0);
	GetHGlobalFromStream(pOutStream,&hg);	
	output = GlobalLock(hg);
	printf("%s",(const char*)output);
	GlobalUnlock(hg);
	
	//release before CoUninitialize()
	pXml.Release();
	pXslt.Release();
	pTemplate.Release();
	pProcessor.Release();



	CoUninitialize();
    getchar();
	return 0;
}


